package com.gic.haoban.manage.api.service;

import com.gic.api.base.commons.Page;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.base.api.common.ServiceResponse;
import com.gic.haoban.manage.api.dto.*;

import java.util.List;

public interface StaffApiService {

	StaffDTO selectById(String staffId);

	StaffDTO selectSuperByWxEnterpriseId(String wxEnterpriseId);

	List<StaffDTO> listByIds(List<String> staffIds);

	List<StaffDTO> listByWxUserId(String wxUserId);

	StaffDTO selectByNationcodeAndPhoneNumber(String wxEnterpriseId, String nationcode, String phoneNumber);

	ServiceResponse add(StaffDTO staff, String departmentIds);

	List<StaffDepartmentRelatedDTO> listStaffDepartmentByStaffId(String staffId);

	Page<StaffDTO> pageStaff(List<String> departmentId, Integer activeFlag, String keyword, BasePageInfo pageInfo, Integer relationFlag);

	void del(String staffDepartmentStaffRelatedId);

	/**
	 * 获取微信成员
	 *
	 * @param userId
	 * @param wxEnterpriseId
	 * @return
	 */
	ServiceResponse getWxSaveNew(String userId, String wxEnterpriseId);

	void wxGetAdd(String userId, String wxEnterpriseId);

	void staffEdit(StaffDTO staffDTO, String departmentIds);

	void syscGicClerk(String fieldListString);

	StaffDTO selectByUserIdAndEnterpriseId(String userId, String wxEnterpriseId);

	StaffDepartmentRelatedDTO getDepartmentIdAndStaffId(String departmentId, String staffId);

	int countByDepartmentId(String departmentId);

	void syncGicClerk(String fieldListString);

	void addGicClerk(GicClerkDTO clerkDTO);

	StaffDepartmentRelatedDTO getDepartmentIdAndCode(String departmentId, String code);

	void initWxUser(String corpid, String contactSecret, String wxEnterpriseId, Integer wxDepartmentId, String taskId);

	List<String> listUnBindClerk(String storeId);

	void cleanGicClerk(String clerkCode, String departmentId);

	String insertUserLoginLog(UserLoginLogDTO userLoginLogDTO);

	int countByDepartmentIds(List<String> departmentIds);

	List<StaffDTO> listByPhoneNumber(String phoneNumber);

	List<StaffDTO> listByUserIdsAndWxEnterpriseId(List<String> userIds, String wxEnterpriseId);

	/**
	 * 保存gic成员
	 *
	 * @param clerkDTO
	 * @return
	 */
	ServiceResponse saveSyncStaffByGic(GicClerkDTO clerkDTO);

	/**
	 * 获取成员头像
	 *
	 * @param clerkCode
	 * @param storeId
	 * @return
	 */
	ServiceResponse<String> getStaffQrcode(String clerkCode, String storeId);

	void wxFristAdd(String userJson, String wxEnterpriseId);

	List<String> listBindClerkUserId(String storeId);

	List<StaffClerkRelationDTO> listBindRelationUserId(String storeId);

	/**
	 * 激活
	 *
	 * @param staffId
	 * @return
	 */
	boolean activeStaff(String staffId);

	/**
	 * 获取一个staff
	 *
	 * @param wxEnterpriseId
	 * @return
	 */
	StaffDTO getWxStaffOne(String wxEnterpriseId);

	/**
	 * @param wxEnterpriseId
	 * @return
	 */
	StaffDTO getAndAddSupperAdmin(String wxEnterpriseId);


	/**
	 * 是否隐私
	 *
	 * @param staffId 员工id
	 * @return {@link StaffPrivacyUseLogDTO }
	 * @author mozhu
	 * @date 2021-12-16 19:53:48
	 */
	StaffPrivacyUseLogDTO getStaffPrivacyByStaffId(String staffId);
}
