package com.gic.haoban.manage.web.controller;

import com.gic.haoban.common.anno.IgnoreLogin;
import com.gic.haoban.common.utils.EntityUtil;
import com.gic.haoban.common.utils.HaobanResponse;
import com.gic.haoban.manage.api.dto.DictDTO;
import com.gic.haoban.manage.api.service.DictApiService;
import com.gic.haoban.manage.web.errCode.HaoBanErrCode;
import com.gic.haoban.manage.web.vo.DictVo;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Arrays;
import java.util.List;

/**
 * Created 2020/3/26.
 *
 * @author hua
 */
@RestController
public class DictController extends WebBaseController {

    @Autowired
    private DictApiService dictApiService;

    @RequestMapping("/dict-list")
    public HaobanResponse queryDictList(String dictKeys) {
        if (StringUtils.isBlank(dictKeys)) {
            return resultResponse(HaoBanErrCode.ERR_5);
        }
        String[] split = dictKeys.split(",");
        List<DictDTO> ret = dictApiService.queryList(Arrays.asList(split));
        return resultResponse(HaoBanErrCode.ERR_1, EntityUtil.changeEntityListByOrika(DictVo.class, ret));
    }

    /**
     * 根据key查询一条数据
     *
     * @param dictKey
     * @return
     */
    @RequestMapping("/find-dict-key")
    @IgnoreLogin
    public HaobanResponse queryDictByKey(String dictKey) {
        if (StringUtils.isBlank(dictKey)) {
            return resultResponse(HaoBanErrCode.ERR_5);
        }
        return resultResponse(HaoBanErrCode.ERR_1, dictApiService.findOneDictByKey(dictKey));
    }
}
